/*----------------------------------------------------------*
 *                                                          *
 * Korean Part-Of-Speech Tagging System ( kts ) Version 0.9 *
 *                                                          *
 * Sang Ho Lee                                              *
 *                                                          *
 * jhlee@csone.kaist.ac.kr shlee2@adam.kaist.ac.kr          *
 *                                                          *
 * Computer Systems Lab.                                    *
 * Computer Science , KAIST                                 *
 *                                                          *
 * irrtbl.h ( Korean POS Tagging System : irr table )       *
 *                                                          *
 *----------------------------------------------------------*/

#define YONGEON1  356 /* 1 ¥             */
#define YONGEON2  308 /* 2 ¥             */
#define YONGEON3  191 /* 3 ¥             */
#define BUSA1     189 /* 1 ¥ λ            */
#define BUSA2     517 /* 2 ¥ λ            */
#define BUSA3     139 /* 3 ¥ λ            */
#define BUSA4     362 /* 4 ¥ λ            */
#define BUSA5      79 /* 5 ¥ λ            */
#define EXCL      240 /*  ź            */

#ifdef BASELING2
#define NOTMORPH   10
#else
#define NOTMORPH   1
#endif



typedef struct _eumjeoltbl_ {
  unsigned char *eumjeolset ; 
  int size ; 
} EUMJEOLTBL ; 

/*
 * `',`',`',`',`'  
 *     
 *    40 ۿ ʵȴ.
 */

/*
 *  ù  Ǵ  : 48 + 1 "" (½, 151) 
 * ߰: (ݾ,,)
 */
unsigned char josa_set_1[] ="԰´ϴٴ\
θۺμƾ߾Ϳ\
óġĿ";


/*
 *   ° ̻  Ǵ  : 48 (½, 151) 
 * ߰ : ƼҸ (~ݾ,ݼ,,)
 */
unsigned char josa_set_2[] ="԰´ϴٵ\
ηϷи麸μҼս᾿ƾ߿ɿ\
óġĿŭ";


/*
 * "" ־ "","ͼ" ó 
 * "" ߰
 * '' ߰  (,÷,,緡)
 * ߰:  (ؾ,;..)  (ʽÿ..)
 *
 *  ù  Ǵ  : 72 + "" (½, 151) 
 * ߰ : "󰡱"(,ױ...)
 */
unsigned char eomi_set_1[]= "ŰǰͰ԰䳪ĳ׳\
´ϴٴܴǵ󷡶÷\
ǷθŸǻ缭Ҽʾƾ߾ÿɿܿ\
";


/*
 *   ° ̻  Ǵ  : 105 ;; (½, 151)
 * ߰ :  (~ݾ)
 */
unsigned char eomi_set_2[]= "Űɰ񲲲ٲ\
״´ôϴٴܴǵ\
÷ŷǷηϷḦŸո鹫ǹٹ\
λӻżҼýƾ߾𿡿ɿͿܿ\
ġŭ";


/* 
 * ''    (½54)
 * char syl_eu[]= "߸ھũƮ";
 */


/*
 * ''    (½ 65) 
 *  '' ۵Ǵ ̿ Ͽ  ''  Ҷ 
 * char syl_a[]="󸶻¥Ÿ";
 */

/* 
 * ''    (½66)
 * char syl_eo[]="ʼ";
 */


/*
 * 1    Ǵ  : 356
 * "Ѥ,̤,Ǥ," 
 */
unsigned char syl_yongeon_1[]=
 "Ȱɰ˰԰ްı\
߱²òŲȲҲٲݲ\
γгѳֳôĴʴ۴ݴ޴\
ǵεڵ϶նٶ߶츶\
øŸʸθԸָܸ޸˹̹Ϲйӹ׹ڹ޹\
ƺ˺ѺҺӺ׺ٺ̻ջ߻\
ӼԼּڼĽŽƽȽɽͽν׽ؽ޽\
þľȾɾʾ˾̾ξѾĿſǿܿ\
\
¢£¤¥ª°ãäġũŰŸ\
ƢƮƲƷǪǮǰȣȧ";


/*
 * 2    Ǵ  : 308 
 * "Ѥ,̤" 
 */
unsigned char syl_yongeon_2[] =
 "Ȱɰ̰аӰڰıͱ۱ݱ߱\
ŲȲҲٲγγгѳֳ׳\
ϴôĴʴ̴ϴҴ۴ݴ޴ǵεӵڵ\
Զնٶ߶Ʒӷڷ縣\
¸øĸŸθԸָݸ޸̹Ϲӹڹ޹\
ҺӺ׺ٺ̻ջڻּڼ\
ĽŽƽɽͽν׽ؽþȾɾ˾Ѿ־ɿ\
¢¤\
¥¨¬½ãäġĥŬŰŸžƮ\
ƲƼǮ";


/*
 * 3 ̻    Ǵ  : 191
 */
unsigned char syl_yongeon_3[] = 
 "Ȱɰ̰Ӱıͱ۱߱ŲȲҲٲ\
ѳֳĴϴҴݴ޴뵹ǵεӵٶ\
ӷ縣¸øĸŸԸݸ޸̹йڹ޹\
Һ׺ٺ̻ڻŽν׽޽Ⱦɾʾ\
ɿݾ¢¤¥½\
äġĥũŰŸƢƮƲƼǮ";


/*
 * 1 λ   Ǵ  : 189
 * 'Ф, 
 */
unsigned char syl_busa_1[] = 
 "԰˲βϲвѲڲôٴڴܴ\
յĶǶȶѶѶٸŸɸ׹ڹκϺغ\
ͻ׻߻ݼϽٽžȾ޾ֿ\
ۿ¦¯¸½äô÷\
ĬĴĻĽľűŹơǪ\
ǫǳȣȤȮȴȸȹȤ" ; 


/*
 * 2 λ   Ǵ  : 517
 */
unsigned char syl_busa_2[] = 
 "Űưɰ̰ϰ԰Ǳٱݱޱ߱\
òǲ˲̲βвѲϲزٲڲڲܲ\
ȳɳ´ϴҴٴڴܴ޴\
ĵǵεϵѵյ\
Ķȶʶ˶ͶѶҶԶ׶Զ·ʷηϷз\
ŸɸӸ۸˹̹ڹݹ߹\
κϺк׺غȻͻһӻֻ׻߻\
ҼӼռּۼݼ½ýĽŽǽ˽Ͻҽֽ\
žƾǾӾ־޾߾ÿ\
пտֿ׿ۿۿ\
¡¦©¬¯°±\
³¸½¿âäóôõö÷øû\
üġģħĩĬĲĴĻĽľ\
ūůűųŷŹŻŽơƯƲ\
ǪǫǬǮǲǳ\
ȣȦȦȩȫȮȰȱȲȳȴȸȹ" ; 


/*
 * 3 λ   Ǵ  : 139
 */
unsigned char syl_busa_3[] = 
 "ǰ԰ݱⲯòٲ´ϴٴڴ޴\
εϵյĶ׶ηϷ踣\
̹ٹݺкҺ߻ҼýŽǽƾ߾\
¦óûüħĪŭư\
Ǫȣ" ; 


/*
 * 4 λ   Ǵ  : 362
 */ 
unsigned char syl_busa_4[] = 
 "ưǰɰ˰̰ϰ԰ݰͱٱ۱ݱ\
򲩲òǲβٲڲʴôƴϴҴٴڴܴ޴\
εϵеѵ\
ȶʶ˶ҶԶ׶ǷʷηϷշ\
Ըָ۸޸̹йԹ\
߹ϺĻһӻֻ߻\
ӼؼۼýŽǽɽ˽νϽҽֽǾ˾Ͼ߾\
˿\
¥¦¯°½\
âô÷øûġģĥħĩĬĲūŭŰŸŹ\
ŻſƲƴǪǫǬȣ" ; 


/*
 * 5 λ   Ǵ  : 79
 */
unsigned char syl_busa_5[] = 
 "԰ͱⲤ´ϴٴڴϵյߵ˶׶\
ηϷշԸݹһ꼺Ǿ˾\
½" ; 


/*
 *  ź   Ǵ  : 240
 * 'ԤŤ'
 */
unsigned char syl_excl[] = 
 "°Űɰ԰ױٱٲ\
ʳ˳׳´̴ϴѴٴܴεյֵ\
ŷηշ踥ŸǸӸո𹫹̹ٹݹ麰\
Ҽýʽνڽ꾮ƾǾϾѾӾ\
׾޾߾¿˿Ϳտֿܿ޿\
¼\
õüġĥīĿũŰŸƮưƾǮȣ\
ȩȭ" ; 

/*
 * ¼Ұ     : 20
 */

/*
unsigned char not_syl_morph[] = 
  "׳´õӾ̽ŭ" ; 
*/

unsigned char not_syl_morph[] = 
  "¸" ; 


EUMJEOLTBL yongeonTbl[3] = {
   { syl_yongeon_1 , YONGEON1 } , 
   { syl_yongeon_2 , YONGEON2 } , 
   { syl_yongeon_3 , YONGEON3 }
 } ; 

EUMJEOLTBL busaTbl[5] = {
   { syl_busa_1 , BUSA1 } , 
   { syl_busa_2 , BUSA2 } , 
   { syl_busa_3 , BUSA3 } , 
   { syl_busa_4 , BUSA4 } , 
   { syl_busa_5 , BUSA5 }
 } ; 

EUMJEOLTBL exclTbl[1] = {
   { syl_excl   , EXCL }
 } ; 

EUMJEOLTBL notmorphTbl[1] = {
   { not_syl_morph , NOTMORPH }
 } ; 


/*********************************************
 *****         End of ktssyll.h          *****
 *********************************************/

