/*----------------------------------------------------*
 *                                                    *
 * Korean Part-Of-Speech Tagger ( KTS ) Version 0.9   *
 *                                                    *
 * Sang Ho Lee                                        *
 *                                                    *
 * jhlee@csone.kaist.ac.kr shlee2@adam.kaist.ac.kr    *
 *                                                    *
 * Computer Systems Lab.                              *
 * Computer Science , KAIST                           *
 *                                                    *
 * sem.h ( Korean POS Tagger Semantics Header File )  *
 *                                                    *
 *----------------------------------------------------*/

#ifndef __NUMOFAKO__
#define __NUMOFAKO__ 67   /* AKO */
#endif

#ifndef __NUMOFVKO__
#define __NUMOFVKO__ 120  /* VKO */
#endif

#ifdef __SEMANTICS__

char akoList[__NUMOFAKO__][6] = { /* Part Of Speech Tag Set */
	 "0"      , /* 0  */
	 "1"      , /* 1  */
	 "11"     , /* 2  */
	 "111"    , /* 3  */
	 "112"    , /* 4  */
	 "12"     , /* 5  */
	 "121"    , /* 6  */
	 "122"    , /* 7  */
	 "1221"   , /* 8  */
	 "1222"   , /* 9  */
	 "123"    , /* 10 */
	 "120"    , /* 11 */
	 "13"     , /* 12 */
	 "131"    , /* 13 */
	 "1311"   , /* 14 */
	 "13111"  , /* 15 */
	 "13112"  , /* 16 */
	 "13113"  , /* 17 */
	 "13114"  , /* 18 */
	 "1312"   , /* 19 */
	 "13121"  , /* 20 */
	 "13122"  , /* 21 */
	 "13123 " , /* 22 */
	 "132"    , /* 23 */
	 "1321"   , /* 24 */
	 "1322"   , /* 25 */
	 "1323"   , /* 26 */
	 "2"      , /* 27 */
	 "21"     , /* 28 */
	 "211"    , /* 29 */
	 "2111"   , /* 30 */
	 "2112"   , /* 31 */
	 "21121"  , /* 32 */
	 "21122"  , /* 33 */
	 "212"    , /* 34 */
	 "2121"   , /* 35 */
	 "2122"   , /* 36 */
	 "2123"   , /* 37 */
	 "2124"   , /* 38 */
	 "22"     , /* 39 */
	 "221"    , /* 40 */
	 "2211"   , /* 41 */
	 "2212"   , /* 42 */
	 "2213"   , /* 43 */
	 "2214"   , /* 44 */
	 "2215"   , /* 45 */
	 "23"     , /* 46 */
	 "231"    , /* 47 */
	 "232"    , /* 48 */
	 "233"    , /* 49 */
	 "234"    , /* 50 */
	 "235"    , /* 51 */
	 "2351"   , /* 52 */
	 "2352"   , /* 53 */
	 "2353"   , /* 54 */
	 "2354"   , /* 55 */
	 "2355"   , /* 56 */
	 "2356"   , /* 57 */
	 "2357"   , /* 58 */
	 "236"    , /* 59 */
	 "2361"   , /* 60 */
	 "2362"   , /* 61 */
	 "2363"   , /* 62 */
	 "2364"   , /* 63 */
	 "2365"   , /* 64 */
	 "2366"   , /* 65 */
	 "2367"     /* 66 */
	 } ; 

char vkoList[__NUMOFVKO__][10] = { /* VKO */
	 "0"         , /* 0  */
	 "1"         , /* 1  */
	 "11"        , /* 2  */
	 "110"       , /* 3  */
	 "111"       , /* 4  */
	 "1111"      , /* 5  */
	 "11111"     , /* 6  */
	 "111111"    , /* 7  */
	 "111112"    , /* 8  */
	 "11112"     , /* 9  */
	 "111121"    , /* 10 */
	 "111122"    , /* 11 */
	 "1112"      , /* 12 */
	 "11121"     , /* 13 */
	 "111211"    , /* 14 */
	 "1112111"   , /* 15 */
	 "1112112"   , /* 16 */
	 "1112113"   , /* 17 */
	 "1112114"   , /* 18 */
	 "111212"    , /* 19 */
	 "11122"     , /* 20 */
	 "111221"    , /* 21 */
	 "1112211"   , /* 22 */
	 "1112212"   , /* 23 */
	 "1112213"   , /* 24 */
	 "1112214"   , /* 25 */
	 "111222"    , /* 26 */
	 "112"       , /* 27 */
	 "1121"      , /* 28 */
	 "11211"     , /* 29 */
	 "11212"     , /* 30 */
	 "1122"      , /* 31 */
	 "11221"     , /* 32 */
	 "11222"     , /* 33 */
	 "12"        , /* 34 */
	 "121"       , /* 35 */
	 "1211"      , /* 36 */
	 "12111"     , /* 37 */
	 "121111"    , /* 38 */
	 "121112"    , /* 39 */
	 "121113"    , /* 40 */
	 "12112"     , /* 41 */
	 "121121"    , /* 42 */
	 "121122"    , /* 43 */
	 "121123"    , /* 44 */
	 "1212"      , /* 45 */
	 "1213"      , /* 46 */
	 "122"       , /* 47 */
	 "1221"      , /* 48 */
	 "1222"      , /* 49 */
	 "1223"      , /* 50 */
	 "1224"      , /* 51 */
	 "1225"      , /* 52 */
	 "2"         , /* 53 */
	 "21"        , /* 54 */
	 "211"       , /* 55 */
	 "212"       , /* 56 */
	 "2121"      , /* 57 */
	 "2122"      , /* 58 */
	 "2123"      , /* 59 */
	 "22"        , /* 60 */
	 "221"       , /* 61 */
	 "2211"      , /* 62 */
	 "22111"     , /* 63 */
	 "221111"    , /* 64 */
	 "2211111"   , /* 65 */
	 "22111111"  , /* 66 */
	 "221111111" , /* 67 */
	 "221111112" , /* 68 */
	 "22111112"  , /* 69 */
	 "221111121" , /* 70 */
	 "221111122" , /* 71 */
	 "2211112"   , /* 72 */
	 "22111121"  , /* 73 */
	 "22111122"  , /* 74 */
	 "22112"     , /* 75 */
	 "221121"    , /* 76 */
	 "2211211"   , /* 77 */
	 "22112111"  , /* 78 */
	 "22112112"  , /* 79 */
	 "2211212"   , /* 80 */
	 "22112121"  , /* 81 */
	 "22112122"  , /* 82 */
	 "221122"    , /* 83 */
	 "2212"      , /* 84 */
	 "22121"     , /* 85 */
	 "22122"     , /* 86 */
	 "222"       , /* 87 */
	 "2221"      , /* 88 */
	 "22211"     , /* 89 */
	 "222111"    , /* 90 */
	 "2221111"   , /* 91 */
	 "2221112"   , /* 92 */
	 "222112"    , /* 93 */
	 "2221121"   , /* 94 */
	 "2221122"   , /* 95 */
	 "2221123"   , /* 96 */
	 "22212"     , /* 97 */
	 "2222"      , /* 98 */
	 "22221"     , /* 99 */
	 "22222"     , /* 100 */
	 "22223"     , /* 101 */
	 "22224"     , /* 102 */
	 "3"         , /* 103 */
	 "31"        , /* 104 */
	 "32"        , /* 105 */
	 "321"       , /* 106 */
	 "322"       , /* 107 */
	 "323"       , /* 108 */
	 "4"         , /* 109 */
	 "41"        , /* 110 */
	 "411"       , /* 111 */
	 "4111"      , /* 112 */
	 "41111"     , /* 113 */
	 "41112"     , /* 114 */
	 "4112"      , /* 115 */
	 "41121"     , /* 116 */
	 "41122"     , /* 117 */
	 "42"        , /* 118 */
	 "5"           /* 119 */
         } ; 

#else

extern char akoList[__NUMOFAKO__][6]  ; 
extern char vkoList[__NUMOFVKO__][10] ;  

#endif


