#include "encoding.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

/**
	@file     encoding.c
	@brief    문자열을 변경하는 프로그램.
	KTS가 현재 euc-kr 체계로 현재 utf-8 -> euc-kr 변경이 필요함
	클라이언트 encoding에 따른 자동변경루틴이 필요함
*/
void  encoding( const char *text
    , const char* to
    , const char* from
	, char* output )
{
#ifndef WIN32
    char* inbuf1[2048];
 
    iconv_t cd = (iconv_t)-1;
    char *inbuf = (char *)inbuf1;
    char *outbuf1 = NULL, *outbuf2 = NULL;
    size_t in = 0, out = 0;

    if( strcmp( (const char *)to
        , (const char *)from ) == 0 ) {
		strcpy( output
			, text );
	}

    memset( inbuf1
        , 0
        , 2048 );

    strcpy( (char *)inbuf1
        , text );

    in = strlen( text );
    out = in * 2;

    outbuf1 = outbuf2 = (char *)malloc( out + 1 );

    memset( outbuf1, 0, out + 1 );

    cd = iconv_open( (const char*)to
        , (const char *)from );

    if( (iconv_t)-1 == cd )
	{
		free( outbuf1 );
        return;
	}

    if( iconv( cd
        , &inbuf
        , &in
        , &outbuf2
        , &out ) == -1 )
    {
		free( outbuf1 );
        return;
    }

	strcpy( output
		, outbuf1 );

	free( outbuf1 );
#else
#endif
}
